<template>
  <div class="student-data">
    <b-field label="Matrícula"></b-field>
      <b-field grouped>
        <b-input
          id="studentdata"
          name="studentdata"
          v-model="studentRegistration"
          maxlength="14"
          expanded
          pattern="^(\d{14}|\d{13})$"
          validation-message="Apenas sequëncia numérica de 14 dígitos"
          required
          value=""></b-input>
          <p class="control">
						<b-button
              @click="onChange($event)"
              class="button is-primary">Procurar dados</b-button>
          </p>
      </b-field>
      <b-notification
        v-if="error"
        class="miss-student-notification"
        type="is-danger"
        has-icon
        aria-close-label="Fechar notificação"
        role="alert">
        A matrícula informada não foi econtrada. Isso pode acontecer por vários mótivos. Os
        principais são:
        <ul>
          <li><b-icon size="is-small" icon="check"></b-icon> Matrícula informada errada;</li>
          <li><b-icon size="is-small" icon="check"></b-icon> A matrícula não corresponde a uma matrícula de aluno do Campus {{ campus }};</li>
          <li><b-icon size="is-small" icon="check"></b-icon> Sua matrícula ainda não está em nossa base de dados, pode acontecer caso você seja aluno novo;
          Nesse caso, entre em contato com a área de T.I do campus.</li>
        </ul>
      </b-notification>
    <b-loading :is-full-page="true" :active.sync="isLoading" :can-cancel="false"></b-loading>
  </div>
</template>

<script>
import Vue from 'vue'
import axios from 'axios'
import messages from '@/utils/messages'

export default {
  name: 'StudentData',
  props: {},
  data: function ()  {
    return {
      studentRegistration: '',
      isLoading: false,
      error: false
    }
  },
  created () {},
  components: {},
  methods: {
    save () {},
    cancel () {},
    onChange () {
      this.isLoading = true
      var message = ''
      var url = Vue.config.urlBase + '/api/estudantes/' + this.studentRegistration
      var options = {
        headers: {
          Accept: 'application/json',
        }
      }
      axios.get(url, options)
        .then(response => {
          var student = response.data
          // student['studentRegistration'] = this.studentRegistration
          this.$emit('userChanged', student)
          return response
        })
        .catch(error => {
          if (error.response.status == 500) {
            message = 'Requisição falhou: erro interno do servidor (500).'
            messages.showSnackbar(message, 'is-danger')
          } else if (error.response.status === 401) {
            message = 'Requisição falhou: não autorizado (401).'
            messages.showSnackbar(message, 'is-danger')
          } else if (error.response.status === 404) {
            this.error = true
            // message = 'Requisição falhou: recurso não encontrado (404).'
            // messages.showSnackbar(message, 'is-danger')
          } else {
            message = 'Requisição falhou: ' + error.toString().split(':')[1] + '.'
            messages.showSnackbar(message, 'is-danger')
          }
          return error
        })
        .finally(() => {
          this.isLoading = false
      })
    },

  },
  computed: {
    campus () {
      return process.env.VUE_APP_IF_CAMPUS
    }
  }
}
</script>
<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped lang="css">
</style>
